﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Net.Http.Headers;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.IO;
using OsobyJmP;



namespace _03_2_oop
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        /*
         * "Databáze V1.0 Autor David Tomek 14.9.2024 
         *  https://home.spsostrov.cz/~tomeda/ 
         *  unixuser@seznam.cz"
         * 
         * */


        string radka;
        string[] vstup;
        List<Osoba> osoby = new List<Osoba>();
        int id=0,id2=0, vek=0, count=0;
        string jmeno=null, prijmeni=null, povolani=null;


        Osoba osobaRemove = new Osoba(0, "", "", 0, "");




        private void buttonPridej_Click(object sender, EventArgs e)
        {
            jmeno = textBoxJmeno.Text;
            prijmeni = textBoxPrijmeni.Text;
            povolani = textBoxPovolani.Text;
            if (!(int.TryParse(textBoxVek.Text.ToString(), out vek))) vek = 1;

            if (jmeno == "") jmeno = "Nezadáno";
            if (prijmeni == "") prijmeni  = "Nezadáno";
            if (povolani == "") povolani = "Nezadáno";

            
            id++;
            osoby.Add(new Osoba(id, jmeno, prijmeni, vek, povolani));
            listBox1.Items.Add(id + "\t\t\t" + jmeno + "\t\t\t" + prijmeni + "\t\t\t" + vek + "\t\t\t"+  povolani + "\t\t\t");

        }

        private void buttonOdstran_Click(object sender, EventArgs e)
        {
            int.TryParse(textBoxID.Text.ToString(),out id2);

            foreach (Osoba osoba in osoby)
            {
                count++;
                id = osoba.id;
                jmeno = osoba.jmeno;
                prijmeni = osoba.prijmeni;
                povolani = osoba.povolani;
                vek = osoba.vek;
                if (osoba.id == id2)
                {
                    osobaRemove = osoba;
                    osoby.Remove(osobaRemove);
                    listBox1.Items.Remove(id + "\t\t\t" + jmeno + "\t\t\t" + prijmeni + "\t\t\t" + vek + "\t\t\t" + povolani + "\t\t\t");
                    count = 0;
                    break;
                }
                if ((osoba.id != id2) && count==osoby.Count)
                {
                    MessageBox.Show("Položka nenalezena !");
                    count = 0;
                }
            }
        }

        private void buttonUprav_Click(object sender, EventArgs e)
        {
            int.TryParse(textBoxID.Text.ToString(), out id2);

            foreach (Osoba osoba in osoby)
            {
                count++;
                if (osoba.id == id2)
                {
                    jmeno = textBoxJmeno.Text.ToString();
                    prijmeni = textBoxPrijmeni.Text.ToString();
                    int.TryParse(textBoxVek.Text.ToString(),out vek);
                    povolani = textBoxPovolani.Text.ToString();
                    osoba.jmeno = jmeno;
                    osoba.prijmeni = prijmeni;
                    osoba.vek = vek;
                    osoba.povolani = povolani;
                    listBox1.Items.RemoveAt(count);
                    listBox1.Items.Insert(count, (id2 + "\t\t\t" + jmeno + "\t\t\t" + prijmeni + "\t\t\t" + vek + "\t\t\t" + povolani + "\t\t\t"));
                    count = 0;
                    break;

                }
                if ((id != id2) && count == osoby.Count)
                {
                    MessageBox.Show("Položka nenalezena !");
                    count = 0;
                }
               
            }
          
        }


        private void buttonVymazObsah_Click(object sender, EventArgs e)
        {
            listBox1.Items.Clear();
        }

        private void buttonVymazDatabazi_Click(object sender, EventArgs e)
        {
            osoby.Clear();
        }

        private void buttonNactiObsahZDatabaze_Click(object sender, EventArgs e)
        {
            id = 0;
            listBox1.Items.Clear();
            listBox1.Items.Add("ID\t\t Jméno\t\t Příjmení\t\t Věk\t\t Povolání");

            foreach (Osoba osoba in osoby)
            {
                id = osoba.id;
                jmeno = osoba.jmeno;
                prijmeni = osoba.prijmeni;
                povolani = osoba.povolani;
                vek = osoba.vek;
                listBox1.Items.Add(id + "\t\t\t" + jmeno + "\t\t\t" + prijmeni + "\t\t\t" + vek + "\t\t\t" + povolani + "\t\t\t");
            }

        }
        private void buttonWriteToCSV_Click(object sender, EventArgs e)
        {

            if (saveFileDialog1.ShowDialog() == DialogResult.OK)
            {
                StreamWriter souborW = new StreamWriter(saveFileDialog1.FileName);
                foreach (Osoba osoba in osoby)
                {
                    souborW.WriteLine(osoba.id + ";" + osoba.jmeno + ";" + osoba.prijmeni + ";" + osoba.vek + ";" + osoba.povolani + ";");
                }
                textBoxSoubor.Text = saveFileDialog1.FileName.ToString();
                souborW.Close();

            }

        }
        private void buttonReadFromCSV_Click(object sender, EventArgs e)
        {
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                osoby.Clear();
                listBox1.Items.Clear();
                StreamReader souborR = new StreamReader(openFileDialog1.FileName);
                listBox1.Items.Add("ID\t\t Jméno\t\t Příjmení\t\t Věk\t\t Povolání");
                
                while ((radka=souborR.ReadLine()) != null)
                {
                    vstup = radka.Split(';');
                    if (vstup.Length == 6)
                    {
                         int.TryParse(vstup[0], out id);
                         jmeno = vstup[1];
                         prijmeni = vstup[2];
                         int.TryParse(vstup[3], out vek);
                         povolani = vstup[4];
                         osoby.Add(new Osoba(id, jmeno, prijmeni, vek, povolani));
                         listBox1.Items.Add(id + "\t\t\t" + jmeno + "\t\t\t" + prijmeni + "\t\t\t" + vek + "\t\t\t" + povolani + "\t\t\t");
                     }
                     else
                     {
                         osoby.Clear();
                         listBox1.Items.Clear(); 
                         textBoxSoubor.Text = null;
                         MessageBox.Show(" Data nelze načíst ! !");
                         textBoxSoubor.Text = "Neplatný formát ! " + openFileDialog1.FileName.ToString();
                         break;
                     }
                }
                if (vstup.Length == 6) textBoxSoubor.Text = openFileDialog1.FileName.ToString();
                souborR.Close();
            }
        }

        private void buttonExitProgram_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void buttonOAutorovi_Click(object sender, EventArgs e)
        {
            MessageBox.Show("Databáze V1.0 Autor David Tomek 14.9.2024 https://home.spsostrov.cz/~tomeda/ , unixuser@seznam.cz");
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            listBox1.Items.Add("ID\t\t Jméno\t\t Příjmení\t\t Věk\t\t Povolání");
            // openFileDialog1.Filter = "CSV (*.csv)|*.csv|txt (*.txt)|*.txt|Vše (*.*)|*.*";
              openFileDialog1.Filter = "CSV (*.csv)|*.csv";
              saveFileDialog1.Filter = "CSV (*.csv)|*.csv";

        }
    }
}

namespace OsobyJmP
{
    class Osoba
    {
       public int id;
       public string jmeno;
       public string prijmeni;
       public int vek;
       public string povolani;

        public Osoba(int id,string jmeno,string prijmeni,int vek,string povolani)
        {
            this.id = id;
            this.jmeno = jmeno;
            this.prijmeni = prijmeni;
            this.vek = vek;
            this.povolani = povolani;
        }
    }
}

